

--  ------------  Generated from [../../../Source/CommServer/WFDB/Upgrade/WF_ProcessSteps.upg] ---------- 

BEGIN

DECLARE @oldRev CHAR(20)    		
  	DECLARE @oldVal CHAR(256)			
  	DECLARE @retCode   INTEGER			
  	DECLARE @sqlError  INTEGER			
  	SET     @retCode = 0              	
  	DECLARE @sqlString nvarchar(MAX)	
  	DECLARE @macroValue nvarchar(MAX)	
      DECLARE @parentID INTEGER				
      DECLARE @tName nvarchar(128)			
      DECLARE @colID INTEGER					
      DECLARE @constId INTEGER				
      DECLARE @cName   nvarchar(128)			
  	DECLARE @oldConstraintName   nvarchar(128)	
  	DECLARE @newConstraintName   nvarchar(128)	
  	DECLARE @oldDataType         nvarchar(64)	
  	DECLARE @keyname   nvarchar(128)		
      DECLARE @dbName   nvarchar(128)			
  	DECLARE @IsNullableAttr VARCHAR(100)	
  	DECLARE @DefaultValAttr NVARCHAR(MAX)	
  	DECLARE @DataType     NVARCHAR(	256)	
  	DECLARE @ct_msg			VARCHAR(1024) = ''	
  	DECLARE @ct_tcMsg		VARCHAR(1024) = ''	
  	DECLARE @nl				VARCHAR(3) = CHAR(13) + CHAR(10)	
  	SET ROWCOUNT 0							
  	SET NOCOUNT ON--   Declare/Initialize @oldRev, @oldVal, @retCode

SELECT @dbName = DB_NAME()													
  SELECT @oldRev = (SELECT revision FROM GXDBVersions WHERE name = 'WF_ProcessSteps')	
  IF (@oldRev IS NULL)														
  BEGIN                 														
      SET @oldRev = '0.0'														
  END																			
  IF NOT EXISTS (SELECT * FROM sysobjects										
  WHERE type = 'U'															
  AND name = 'WF_ProcessSteps')														
  BEGIN																		
  	SET @oldRev = '0.0'														
  	DELETE FROM GXDBVersions WHERE name = 'WF_ProcessSteps'							
  END																			
  IF (@oldRev = '1.32')       												
  BEGIN																		
      PRINT 'RETVAL: 0   Table [' +'WF_ProcessSteps' +'] does NOT require upgrade.'	
  	
  END																			
  else																		
  BEGIN																		
      PRINT 'Upgrading Table [' +'WF_ProcessSteps' +'].'							
  END


IF NOT EXISTS (select * from sysobjects where id = object_id(N'[dbo].[WF_ProcessSteps]') and OBJECTPROPERTY(id, N'IsTable') = 1)
BEGIN



--  ------------  Generated from [../../../Source/CommServer/WFDB/Tbl/WF_ProcessSteps.tbl] ---------- 





-- ALLOW_COMMENTS_BELOW_HERE:

-- ----------------------------------------------------------------------

--

--           Copyright (c) 1998  CommVault Systems, Inc.

--                  All rights reserved.

--

--

--        This is unpublished proprietary source code of CommVault

--        Systems, Inc. The copyright notice above does not evidence

--        any actual or intended publication of such source code.

-- ----------------------------------------------------------------------*/

-- rcsid="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/WFDB/Tbl/WF_ProcessSteps.tbl,v $ $Id: WF_ProcessSteps.tbl,v 1.25.42.5 2019/08/01 07:31:08 abilbrey Exp $";

print '... Creating Table: WF_ProcessSteps'

exec ('



DECLARE @tblRetCode integer

Set NOCOUNT ON





create table WF_ProcessSteps (

	ProcessStepId 		INTEGER NOT NULL IDENTITY (1,1),

	ParentId			int NULL,

	jobId 				bigint NOT NULL,

	commCellId			int NOT NULL,

	ContextId			int NOT NULL,

	PathId				int NOT NULL,

	StepId 				int NOT NULL,

	Name 				nvarchar(255)	NOT NULL,

	StartTime 			int NULL,

	EndTime 			int NULL,

	Modified 			int NULL,

	Status 				int NOT NULL,

	State				int NOT NULL,

	Restarts 			int NOT NULL,

	Attempts 			int NOT NULL,

	Executions 			int NOT NULL,

	Phase				int NULL,

	Inputs 				xml NULL,

	Outputs 			xml NULL,

	WorkflowStart		bit NOT NULL,

	fromTransitionId	int NULL,

	subJobId			bigint NULL,

	superProcessId		int NULL,

	sessionId			nvarchar(256) NULL,

	flags				int NULL,

	failureReason				nvarchar(max)NULL,

	wfJobId				bigint NULL,



CONSTRAINT PK_WF_ProcessSteps PRIMARY KEY CLUSTERED (ProcessStepId) WITH (IGNORE_DUP_KEY = OFF) ON [PRIMARY]

) 

set @tblRetCode = @@error

if (@tblRetCode <> 0)

BEGIN

		set @tblRetCode = @@error;

		print ''RETVAL: 10 Table [WF_ProcessSteps]''

END

--------





CREATE INDEX WF_ProcessSteps_jobId_commCellId_StepId_Status_WorkflowStart_idx ON WF_ProcessSteps (jobId,commCellId,StepId,Status) INCLUDE (WorkflowStart)

 

CREATE INDEX IX_WF_ProcessSteps_3 ON WF_ProcessSteps (ParentId)

 

CREATE INDEX IX_WF_ProcessSteps_5 ON WF_ProcessSteps (State)

 

CREATE INDEX IX_WF_ProcessSteps_6 ON WF_ProcessSteps (superProcessId)

 

CREATE INDEX WF_ProcessSteps_ContextId_ParentId_wfJobId_idx ON WF_ProcessSteps (ContextId) INCLUDE (ParentId, wfJobId) WITH (FILLFACTOR = 90)

 

CREATE INDEX WF_ProcessSteps_StepId_ProcessStepId_idx ON WF_ProcessSteps (StepId,ProcessStepId) WITH (FILLFACTOR = 90)

 

CREATE INDEX WF_ProcessSteps_Name_jobId_wfJobId_ParentId_idx ON WF_ProcessSteps (Name,jobId,wfJobId,ParentId) WITH (FILLFACTOR = 90)

 

ALTER TABLE WF_ProcessSteps ADD CONSTRAINT FK_WF_ProcessSteps_WF_Steps FOREIGN KEY(StepId) REFERENCES WF_Steps (StepId)

ALTER TABLE WF_ProcessSteps ADD CONSTRAINT FK_WF_ProcessSteps_WF_Process FOREIGN KEY(jobId,commCellId) REFERENCES WF_Process (jobId,commCellId) ON DELETE CASCADE

insert into GXDBVersions values(1, ''WF_ProcessSteps'',  ''1.25.42.5'', ''WF_ProcessSteps'', '''')

set @tblRetCode = @@error

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 10 Table [GXDBVersions]''

END

-------------------------------------------------------------




')
END
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'WF_ProcessSteps' AND COLUMN_NAME='sessionId')			
  	BEGIN																														
  		SET @sqlString = 'ALTER TABLE ' + 'WF_ProcessSteps'+ ' ADD ' +'sessionId'+ ' ' +'integer'			
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																										
  	END

SET @oldDataType='nvarchar'	
  	IF(@oldDataType LIKE '%char%')				
  	BEGIN										
  		IF(@oldDataType LIKE '%(%)%')			
  		BEGIN									
  			SET @oldDataType = SUBSTRING(@oldDataType, 0, CHARINDEX('(', @oldDataType, 0))	
  		END										
  	END			
  	IF ((@oldDataType!='xml')																
  		AND EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'WF_ProcessSteps'										
  								AND COLUMN_NAME='Outputs' AND DATA_TYPE = @oldDataType))			
  	BEGIN																														
  		SELECT	@IsNullableAttr = (CASE WHEN IS_NULLABLE = 'NO' THEN ' NOT NULL ' ELSE ' NULL ' END),							
  				@DefaultValAttr = (CASE WHEN COLUMN_DEFAULT IS NULL THEN '' ELSE COLUMN_DEFAULT END)				
  		FROM INFORMATION_SCHEMA.COLUMNS																							
  		WHERE TABLE_NAME = 'WF_ProcessSteps' AND COLUMN_NAME='Outputs' AND DATA_TYPE = @oldDataType		
  		IF (LEN(@DefaultValAttr) > 0)																		
  		BEGIN																								
  			SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'WF_ProcessSteps' AND xType = 'U')								
  			SELECT @colID    = (SELECT colid FROM syscolumns WHERE id = @parentID AND NAME='Outputs')			
  			SELECT @constId  = (SELECT a.constid FROM sysconstraints a, sysobjects b							
  						WHERE a.id = @parentID AND a.colid = @colid and a.constid = b.id and b.xtype = 'D')		
  			IF (@constId IS NOT NULL)																			
  			BEGIN																								
  				  SELECT @cName    = (SELECT name FROM sysobjects WHERE id=@constId)							
  				  SET  @sqlString = 'ALTER TABLE [' + 'WF_ProcessSteps' +']' +'DROP CONSTRAINT [' + @cName + ']'		
  				  IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  			END																									
  		END																										
  		SET @sqlString = 'ALTER TABLE ' + 'WF_ProcessSteps'+ ' ALTER COLUMN ' +'Outputs'+ ' ' +'xml'		
  		+ ' ' + @IsNullableAttr 																								
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																											
  		IF (LEN(@DefaultValAttr) > 0)																		
  		BEGIN																								
  			SET @sqlString = 'ALTER TABLE ' + 'WF_ProcessSteps' + ' ADD CONSTRAINT ' + @cName  + ' DEFAULT ' + @DefaultValAttr+ ' FOR ' +'Outputs'		
  			IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																											
  		END																									
  	END

SET @oldDataType='nvarchar'	
  	IF(@oldDataType LIKE '%char%')				
  	BEGIN										
  		IF(@oldDataType LIKE '%(%)%')			
  		BEGIN									
  			SET @oldDataType = SUBSTRING(@oldDataType, 0, CHARINDEX('(', @oldDataType, 0))	
  		END										
  	END			
  	IF ((@oldDataType!='xml')																
  		AND EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'WF_ProcessSteps'										
  								AND COLUMN_NAME='Inputs' AND DATA_TYPE = @oldDataType))			
  	BEGIN																														
  		SELECT	@IsNullableAttr = (CASE WHEN IS_NULLABLE = 'NO' THEN ' NOT NULL ' ELSE ' NULL ' END),							
  				@DefaultValAttr = (CASE WHEN COLUMN_DEFAULT IS NULL THEN '' ELSE COLUMN_DEFAULT END)				
  		FROM INFORMATION_SCHEMA.COLUMNS																							
  		WHERE TABLE_NAME = 'WF_ProcessSteps' AND COLUMN_NAME='Inputs' AND DATA_TYPE = @oldDataType		
  		IF (LEN(@DefaultValAttr) > 0)																		
  		BEGIN																								
  			SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'WF_ProcessSteps' AND xType = 'U')								
  			SELECT @colID    = (SELECT colid FROM syscolumns WHERE id = @parentID AND NAME='Inputs')			
  			SELECT @constId  = (SELECT a.constid FROM sysconstraints a, sysobjects b							
  						WHERE a.id = @parentID AND a.colid = @colid and a.constid = b.id and b.xtype = 'D')		
  			IF (@constId IS NOT NULL)																			
  			BEGIN																								
  				  SELECT @cName    = (SELECT name FROM sysobjects WHERE id=@constId)							
  				  SET  @sqlString = 'ALTER TABLE [' + 'WF_ProcessSteps' +']' +'DROP CONSTRAINT [' + @cName + ']'		
  				  IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  			END																									
  		END																										
  		SET @sqlString = 'ALTER TABLE ' + 'WF_ProcessSteps'+ ' ALTER COLUMN ' +'Inputs'+ ' ' +'xml'		
  		+ ' ' + @IsNullableAttr 																								
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																											
  		IF (LEN(@DefaultValAttr) > 0)																		
  		BEGIN																								
  			SET @sqlString = 'ALTER TABLE ' + 'WF_ProcessSteps' + ' ADD CONSTRAINT ' + @cName  + ' DEFAULT ' + @DefaultValAttr+ ' FOR ' +'Inputs'		
  			IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																											
  		END																									
  	END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'WF_ProcessSteps' AND COLUMN_NAME='flags')			
  	BEGIN																														
  		SET @sqlString = 'ALTER TABLE ' + 'WF_ProcessSteps'+ ' ADD ' +'flags'+ ' ' +'integer'			
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																										
  	END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'WF_ProcessSteps' AND COLUMN_NAME='failureReason')			
  	BEGIN																														
  		SET @sqlString = 'ALTER TABLE ' + 'WF_ProcessSteps'+ ' ADD ' +'failureReason'+ ' ' +'nvarchar(MAX)'			
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																										
  	END

SET @oldDataType='int'	
  	IF(@oldDataType LIKE '%char%')				
  	BEGIN										
  		IF(@oldDataType LIKE '%(%)%')			
  		BEGIN									
  			SET @oldDataType = SUBSTRING(@oldDataType, 0, CHARINDEX('(', @oldDataType, 0))	
  		END										
  	END			
  	IF ((@oldDataType!='nvarchar(256)')																
  		AND EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'WF_ProcessSteps'										
  								AND COLUMN_NAME='sessionId' AND DATA_TYPE = @oldDataType))			
  	BEGIN																														
  		SELECT	@IsNullableAttr = (CASE WHEN IS_NULLABLE = 'NO' THEN ' NOT NULL ' ELSE ' NULL ' END),							
  				@DefaultValAttr = (CASE WHEN COLUMN_DEFAULT IS NULL THEN '' ELSE COLUMN_DEFAULT END)				
  		FROM INFORMATION_SCHEMA.COLUMNS																							
  		WHERE TABLE_NAME = 'WF_ProcessSteps' AND COLUMN_NAME='sessionId' AND DATA_TYPE = @oldDataType		
  		IF (LEN(@DefaultValAttr) > 0)																		
  		BEGIN																								
  			SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'WF_ProcessSteps' AND xType = 'U')								
  			SELECT @colID    = (SELECT colid FROM syscolumns WHERE id = @parentID AND NAME='sessionId')			
  			SELECT @constId  = (SELECT a.constid FROM sysconstraints a, sysobjects b							
  						WHERE a.id = @parentID AND a.colid = @colid and a.constid = b.id and b.xtype = 'D')		
  			IF (@constId IS NOT NULL)																			
  			BEGIN																								
  				  SELECT @cName    = (SELECT name FROM sysobjects WHERE id=@constId)							
  				  SET  @sqlString = 'ALTER TABLE [' + 'WF_ProcessSteps' +']' +'DROP CONSTRAINT [' + @cName + ']'		
  				  IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  			END																									
  		END																										
  		SET @sqlString = 'ALTER TABLE ' + 'WF_ProcessSteps'+ ' ALTER COLUMN ' +'sessionId'+ ' ' +'nvarchar(256)'		
  		+ ' ' + @IsNullableAttr 																								
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																											
  		IF (LEN(@DefaultValAttr) > 0)																		
  		BEGIN																								
  			SET @sqlString = 'ALTER TABLE ' + 'WF_ProcessSteps' + ' ADD CONSTRAINT ' + @cName  + ' DEFAULT ' + @DefaultValAttr+ ' FOR ' +'sessionId'		
  			IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																											
  		END																									
  	END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'WF_ProcessSteps' AND COLUMN_NAME='wfJobId')			
  	BEGIN																														
  		SET @sqlString = 'ALTER TABLE ' + 'WF_ProcessSteps'+ ' ADD ' +'wfJobId'+ ' ' +'bigint'			
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																										
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'WF_ProcessSteps' AND xType = 'U')				
      IF EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'IX_WF_ProcessSteps_1')						
      BEGIN																								
  		SET @sqlString = 'DROP INDEX [' + 'WF_ProcessSteps' +'].[' + 'IX_WF_ProcessSteps_1' +']'							
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'WF_ProcessSteps' AND xType = 'U')				
      IF EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'IX_WF_ProcessSteps_2')						
      BEGIN																								
  		SET @sqlString = 'DROP INDEX [' + 'WF_ProcessSteps' +'].[' + 'IX_WF_ProcessSteps_2' +']'							
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'WF_ProcessSteps' AND xType = 'U')				
      IF EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'IX_WF_ProcessSteps_4')						
      BEGIN																								
  		SET @sqlString = 'DROP INDEX [' + 'WF_ProcessSteps' +'].[' + 'IX_WF_ProcessSteps_4' +']'							
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'WF_ProcessSteps' AND xType = 'U')				
      IF EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'IX_WF_ProcessSteps_8')						
      BEGIN																								
  		SET @sqlString = 'DROP INDEX [' + 'WF_ProcessSteps' +'].[' + 'IX_WF_ProcessSteps_8' +']'							
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'WF_ProcessSteps' AND xType = 'U')				
      IF EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'IX_WF_ProcessSteps_wfJobId')						
      BEGIN																								
  		SET @sqlString = 'DROP INDEX [' + 'WF_ProcessSteps' +'].[' + 'IX_WF_ProcessSteps_wfJobId' +']'							
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'WF_ProcessSteps' AND xType = 'U')				
      IF EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'IX_WF_ProcessSteps_7')						
      BEGIN																								
  		SET @sqlString = 'DROP INDEX [' + 'WF_ProcessSteps' +'].[' + 'IX_WF_ProcessSteps_7' +']'							
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'WF_ProcessSteps' AND xType = 'U')				
      IF EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'IX_WF_ProcessSteps_jobId_commCellId_StepId_Status')						
      BEGIN																								
  		SET @sqlString = 'DROP INDEX [' + 'WF_ProcessSteps' +'].[' + 'IX_WF_ProcessSteps_jobId_commCellId_StepId_Status' +']'							
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'WF_ProcessSteps' AND xType = 'U')								
  	IF NOT EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'WF_ProcessSteps_ContextId_ParentId_wfJobId_idx')					
  	BEGIN																								
  	SET @sqlString = 'CREATE INDEX [' + 'WF_ProcessSteps_ContextId_ParentId_wfJobId_idx' +']' + 'ON [' + 'WF_ProcessSteps' +']  (' + 'ContextId' + ') INCLUDE ('+ 'ParentId, wfJobId' + ')  WITH (FILLFACTOR = '	 + '90' +	')'		
  	IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'WF_ProcessSteps' AND xType = 'U')								
  	IF NOT EXISTS(SELECT * FROM sysindexes WHERE id = @parentID AND name = 'WF_ProcessSteps_StepId_ProcessStepId_idx')					
  	BEGIN																								
  		SET @sqlString = 'CREATE INDEX [' + 'WF_ProcessSteps_StepId_ProcessStepId_idx' + ']' + 'ON [' + 'WF_ProcessSteps' + ']  (' + 'StepId,ProcessStepId' + ')  WITH (FILLFACTOR = ' + '90' + ')'		
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'WF_ProcessSteps' AND xType = 'U')								
  	IF NOT EXISTS(SELECT * FROM sysindexes WHERE id = @parentID AND name = 'WF_ProcessSteps_Name_jobId_wfJobId_ParentId_idx')					
  	BEGIN																								
  		SET @sqlString = 'CREATE INDEX [' + 'WF_ProcessSteps_Name_jobId_wfJobId_ParentId_idx' + ']' + 'ON [' + 'WF_ProcessSteps' + ']  (' + 'Name,jobId,wfJobId,ParentId' + ')  WITH (FILLFACTOR = ' + '90' + ')'		
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'WF_ProcessSteps' AND xType = 'U')								
      IF NOT EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'WF_ProcessSteps_jobId_commCellId_StepId_Status_WorkflowStart_idx')					
      BEGIN																								
  		SET @sqlString = 'CREATE INDEX [' + 'WF_ProcessSteps_jobId_commCellId_StepId_Status_WorkflowStart_idx' +']' + 'ON [' + 'WF_ProcessSteps' +']  (' + 'jobId,commCellId,StepId,Status' + ') INCLUDE ('+ 'WorkflowStart' + ')'		
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

IF (@retCode < 10)													
  	BEGIN																
  		IF NOT EXISTS (SELECT * FROM GXDBVersions WHERE name = 'WF_ProcessSteps')			
  			insert into GXDBVersions VALUES(1, 'WF_ProcessSteps', '0.0', 'WF_ProcessSteps', '')	
  			UPDATE GXDBVersions SET revision = '1.32' WHERE name = 'WF_ProcessSteps'		
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), @retCode) + 'Table [' + 'WF_ProcessSteps' + '] upgraded successfully to '			+ ' revision [' + '1.32' + '].'										
  	END																	
  	else																
  		PRINT 'RETVAL: ' + CONVERT(CHAR(5), @retCode) + ' TABLE ' + 'WF_ProcessSteps' + ' Upgrade Completed with Errors.'  
  	RETURN			   -- No more upgrade for this TABLE!-- Update cvTable & return

END

GO
IF @@error <> 0 RETURN
GO
